if not srb2p return end

freeslot("SPR_KLPI", "SPR_SSNO")
charStats["dirk"] = {

		-- GENERAL

		name = "Dirk",			-- This is only for bots / enemies
		basehp = 55,			-- base HP for level 1
		basesp = 45,
		persona = "kelpie_dirk",
		melee_natk = "dirk_atk1",	-- normal melee attack

		wep = "dirk_wep",
		weptype = WPT_PSYGLOVES,

		atk = 32,	-- attack power of physical attacks
		acc = 90,	-- accuracy of physical attacks
		crit = 6,

		supercolor_start = SKINCOLOR_SUPERICY1,	-- if super form is applicable: will use this flash

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
		-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, 10, "SPR2_STND"},      -- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, 1, "SPR2_FALL"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, 1, "SPR2_STND"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- shooting evoker

		anim_stand_super = 			{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},		-- standing
		anim_guard_super =			{SPR_PLAY, A, 1, "SPR2_WALK"},
		anim_move_super =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},
		anim_run_super = 			{SPR_PLAY, A, B, 2, "SPR2_RUN_"},			-- run
		anim_atk_super =			{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},
		anim_aoa_end_super =		{SPR_PLAY, A, B, 1, "SPR2_FALL"},
		anim_hurt_super =			{SPR_PLAY, A, 35, "SPR2_PAIN"},
		anim_getdown_super =		{SPR_PLAY, A, 1, "SPR2_SHIT"},
		anim_downloop_super =		{SPR_PLAY, A, 1, "SPR2_SHIT"},
		anim_getup_super =			{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},
		anim_evoker_super = 		{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, B, C, D, 4, "SPR2_STND"},

		anim_special1 = {SPR_PLAY, A, B, C, D, 2, "SPR2_SPIN"}, -- spindash (revving up)
		anim_special2 = {SPR_PLAY, A, B, C, D, 1, "SPR2_SPIN"}, -- spindash (faster, revved up)
		anim_special3 = {SPR_PLAY, A, 1, "SPR2_WAIT"}, -- gathering cold air
		anim_special4 = {SPR_PLAY, A, 1, "SPR2_PUSH"}, -- dispersing all of it at the enemies

		-- VOICES
		-- Follow this template.
		-- All sounds in there will be *automatically* freeslotted.
		-- For custom characters, call VFX_freeslotC("skinname") OUT OF A THINKFRAME (!)
		-- See Player_Defs.LUA

		vfx_summon = {"sfx_drksu1", "sfx_drksu2", "sfx_drksu3", "sfx_drksu4", "sfx_drksu5", "sfx_drksu6"},				-- Summoning Persona to use a Skill
        vfx_skill = {"sfx_drksk1", "sfx_drksk2", "sfx_drksk3", "sfx_drksk4"},	-- Used a Skill
        vfx_item = {"sfx_drkit1", "sfx_drkit2", "sfx_drkit3"},						-- Used an item
        vfx_hurt = {"sfx_drkht1", "sfx_drkht2", "sfx_drkht3", "sfx_drkht4", "sfx_drkht5", "sfx_drkht6", "sfx_drkht7"},							-- Sustained damage
        vfx_hurtx = {"sfx_drkhx1", "sfx_drkhx2", "sfx_drkhx3", "sfx_drkhx4"},						-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_drkde1", "sfx_drkde2", "sfx_drkde3", "sfx_drkde4", "sfx_drkde5"},		-- Death
        vfx_heal = {"sfx_drkhe1", "sfx_drkhe2", "sfx_drkhe3", "sfx_drkhe4", "sfx_drkhe5"},	-- Healed by teammate
        vfx_healself = {"sfx_drkhs1", "sfx_drkhs2", "sfx_drkhs3"},					-- Healed self
        vfx_kill = {"sfx_drkki1", "sfx_drkki2", "sfx_drkki3", "sfx_drkki4"},							-- Killed an enemy
        vfx_1more = {"sfx_drk1m1", "sfx_drk1m2", "sfx_drk1m3"},						-- Performed 1more
        vfx_crit = {"sfx_drkcr1", "sfx_drkcr2", "sfx_drkcr3"},	-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_drkap1", "sfx_drkap2", "sfx_drkap3", "sfx_drkap4"},					-- Ask to All-Out Attack
        vfx_aoado = {"sfx_drkao1", "sfx_drkao2", "sfx_drkao3", "sfx_drkao4", "sfx_drkao5", "sfx_drkao6", "sfx_drkao7"}, -- Performing All-Out Attack
        vfx_aoarelent = {"sfx_drkad1", "sfx_drkad2", "sfx_drkad3", "sfx_drkad4"},				-- Relenting from All-Out Attack
        vfx_miss = {"sfx_drkmi1", "sfx_drkmi2", "sfx_drkmi3", "sfx_drkmi4", "sfx_drkmi5"},						-- Missed attack
        vfx_dodge = {"sfx_drkdo1", "sfx_drkdo2", "sfx_drkdo3", "sfx_drkdo4"},						-- Dodged enemy attack
        vfx_win = {"sfx_drkwi1", "sfx_drkwi2", "sfx_drkwi3", "sfx_drkwi4", "sfx_drkwi5"},	-- Battle won
        vfx_levelup = {"sfx_drklv1", "sfx_drklv2", "sfx_drklv3", "sfx_drklv4"},					-- Level Up!

		icon = "ICO_DIRK",	-- icon for net select and other menus
		hudbust = "DIRK_H",			-- patch to draw on the stat hud
		hudaoa = "H_DIKAOA",	-- patch for all out attack hud
		hudsbust = "SDIRK_H",
		hudsaoa = "H_SDKAOA",	-- same but for supers
		hudcutin = "DIRK_A",	-- cut in
		aoa_quote = "Always play your\ngame cool.",

		tip = "Learns Ice, Strike, and Debuff skills. What Dirk lacks in pure firepower compared to the other two he makes up for in utility. He can work well in fast or slow teams with his agility debuffs to help mitigate potential damage.",
}

personaList["kelpie_dirk"] = {
		name = "Kelpie",
		arcana = ARCANA_STRENGTH,

		anim_idle = 	{SPR_KLPI, A, K, B, L, C, M, D, N, E, 5}, -- Added 4 more standing sprites for it to be smoother
		anim_atk = 		{SPR_KLPI, F, G, H, H, H, H, I, J, J, J, J, J, J, J, J, J, J, J, 3},

		strength = 7,
		magic = 11,
		endurance = 7,
		luck = 5,
		agility = 10,
		
		weak = ATK_WIND,
		block = ATK_ICE,
		
		skills = {
					{"bufu", 1}, 
					{"lunge", 5},
					{"dia", 9},

					{"sukunda", 13},
					{"mabufu", 17}, 

					{"dodge wind", 20},
					{"bufula", 24, "bufu"},
					{"sonic punch", 28, "lunge"},
					
					{"masukunda", 33, "sukunda"},
					{"mabufula", 36, "mabufu"},
					{"diarama", 39, "dia"},

					{"ice boost", 42},
					{"assault dive", 45, "sonic punch"},
					{"bufudyne", 48, "bufula"},
					
					{"invigorate 2", 51},
					{"frost wave", 54, "masukunda"},
					{"gigantic fist", 57, "assault dive"},
					
					{"ice amp", 63, "ice boost"},
					{"diarahan", 66, "diarama"},
					{"invigorate 3", 69, "invigorate 2"},
					
					{"mabufudyne", 72, "mabufula"},
					{"niflheim", 76, "bufudyne"},
				},
}

weaponsList["dirk_wep"] = { --Starting Weapon
	name = "Dirk's Ice Gloves",
	type = WPT_PSYGLOVES,
	atk = 300,
	rarity = 1,
	slot = "mastery 1",
	desc = "Dirk's Favorite!",
}

VFX_freeslotC("dirk")

attackDefs["dirk_atk1"] = {
		name = "Ice Ring",
		type = ATK_STRIKE,
		power = 35,
		accuracy = 85,
		critical = 999, --lmao crit anim testing
		target = TGT_ENEMY,
		cost = CST_HP,
		cost = 0,
		desc = "Throw an icy ring at an enemy.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
			local target = targets[1]
			local atarget = hittargets[1]
			if timer == 1
				mo.reachedtarget = false
			end
			
			if timer == 15
				ANIM_set(mo, mo.anim_special3, true)
				S_StartSound(mo, sfx_thok)
				mo.icering = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				mo.icering.state = S_FLOATINGICERING
				mo.icering.scale = FRACUNIT*4/3
				mo.icering.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo.icering, mo.icering.angle, FRACUNIT*30)
			end
			if timer == 20
				ANIM_set(mo, mo.anim_stand, true)
			end
			if not mo.reachedtarget
				if mo.icering
				and mo.icering.valid
					if R_PointToDist2(mo.icering.x, mo.icering.y, target.x, target.y) <= FRACUNIT*30
						mo.reachedtarget = timer
						damageObject(atarget)
						playSound(mo.battlen, sfx_bufu4)
						mo.icering.tics = 5
						for i = 1, 30
							local bb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_BUFU_PARTICLE)
							bb.state, bb.scale = i%2 and S_BUFU_PARTICLE_B or S_BUFU_PARTICLE_A, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						end
					end
				end
			else
				if timer > mo.reachedtarget + 20
					mo.reachedtarget = nil
					return true
				end
			end
		end,
		critanim = 	function(mo, targets, hittargets, timer)
			local target = targets[1]
			local atarget = hittargets[1]
			
			if timer == 1
				mo.reachedtarget = false
			end
			
			if timer == 1
			or timer == 11
				ANIM_set(mo, mo.anim_special1, true)
				S_StartSound(mo, sfx_spndsh)
			end
			 
			if timer >= 21
			and timer <= 40
				if leveltime %4 == 0
					local a = R_PointToAngle(mo.x, mo.y)
					local x = mo.x - cos(a)
					local y = mo.y - sin(a)

					local dummy = P_SpawnMobj(x, y, mo.z, MT_DUMMY)
					if mo.skin
						dummy.skin = mo.skin
					end
					dummy.state = mo.state
					dummy.sprite = mo.sprite
					dummy.sprite2 = mo.sprite2
					dummy.frame = mo.frame
					dummy.angle = mo.angle
					dummy.scale = mo.scale
					dummy.colorized = true
					dummy.color = SKINCOLOR_WHITE
					dummy.fuse = 2
				end
				if (timer-1)%10 == 0
					ANIM_set(mo, mo.anim_special2, true)
					S_StartSound(mo, sfx_spndsh)
				end
			end
			
			if timer == 41
				ANIM_set(mo, mo.anim_special3, true)
				S_StartSound(mo, sfx_thok)
				mo.icering = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				mo.icering.state = S_FLOATINGICERING
				mo.icering.scale = FRACUNIT*4/3
				mo.icering.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo.icering, mo.icering.angle, FRACUNIT*40)
			end
			if timer == 46
				ANIM_set(mo, mo.anim_stand, true)
			end
			if not mo.reachedtarget
				if mo.icering
				and mo.icering.valid
					if R_PointToDist2(mo.icering.x, mo.icering.y, target.x, target.y) <= FRACUNIT*40
						mo.reachedtarget = timer
						damageObject(atarget)
						playSound(mo.battlen, sfx_bufu4)
						mo.icering.tics = 5
						for i = 1, 30
							local bb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_BUFU_PARTICLE)
							bb.state, bb.scale = i%2 and S_BUFU_PARTICLE_B or S_BUFU_PARTICLE_A, mo.scale
							bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
						end
					end
				end
			else
				if timer > mo.reachedtarget + 20
					mo.reachedtarget = nil
					return true
				end
			end
		end,
	}

attackDefs["frost wave"] = {
		name = "Frost Wave",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 36,
		accuracy = 25,
		statuschance = 25,
		desc = "Lowers Agility & Attack \nwith a low chance of \nfreezing all enemies.",
		target = TGT_ALLENEMIES,
		status = COND_FREEZE,
		luckbased = true,
		debuff = true,
		norepel = true,
		anim = function(mo, targets, hittargets, timer)
					local avgx, avgy = 0, 0
					for i = 1, #targets
						avgx = $ + targets[i].x/FRACUNIT
						avgy = $ + targets[i].y/FRACUNIT
					end
					avgx = ($/#targets)*FRACUNIT
					avgy = ($/#targets)*FRACUNIT

					if timer == 1 
						playSound(mo.battlen, sfx_bufu5)
					end
					if timer < 20
						ANIM_set(mo, mo.anim_special3, true)
						if leveltime%2 == 0
							for i = 1, 2
								local dust = P_SpawnMobj(mo.x+P_RandomRange(-32, 32)*FRACUNIT, mo.y+P_RandomRange(-32, 32)*FRACUNIT, mo.z+P_RandomRange(0, 64)*FRACUNIT, MT_DUMMY)
								dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
								dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT, 0
								dust.destscale = FRACUNIT*9/4
								dust.scalespeed = FRACUNIT/18
							end
						end
					end
					//this is where the dust moves towards the target
					if timer > 50 and timer < 80
						for i = 1,64
							local dust = P_SpawnMobj(mo.x+P_RandomRange(60,-60)*FRACUNIT, mo.y+P_RandomRange(60,-60)*FRACUNIT, mo.z+P_RandomRange(60,-60)*FRACUNIT, MT_DUMMY)
							if dust.x < mo.x - 50
							and dust.x < mo.x + 50
							and dust.y < mo.y - 50
							and dust.y < mo.y + 50
							and dust.z < mo.z - 50
							and dust.z < mo.z + 50
								P_RemoveMobj(dust)
							else
								local zawindo = P_RandomRange(-45, 45)
								dust.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
								dust.state, dust.scale, dust.angle = S_BUFUDYNE_DUST1, FRACUNIT, (R_PointToAngle(avgx, avgy)) + ANG1*zawindo
								dust.destscale = FRACUNIT*9/4
								dust.scalespeed = FRACUNIT/18
								P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
							end
						end
					end
					
					if timer == 50
						ANIM_set(mo, mo.anim_special4, true)
						playSound(mo.battlen, sfx_prloop)
					end
					
					if timer == 60
						playSound(mo.battlen, sfx_bufu3)
						for i = 1, #hittargets
							buffStat(hittargets[i], "agi", -BUFFSTEP)
							buffStat(hittargets[i], "atk", -BUFFSTEP)
							damageObject(hittargets[i])
							BTL_logMessage(hittargets[i].battlen, hittargets[i].name.."'s Attack & Agility were lowered!")
						end
					end
					if timer == 90
						return true
					end
				end,
}

---------------------------------

charStats["whirl"] = {

		-- GENERAL

		name = "Whirl",			-- This is only for bots / enemies
		basehp = 67,			-- base HP for level 1
		basesp = 33,
		persona = "susano-o_whirl",
		melee_natk = "whirl_atk1",	-- normal melee attack

		wep = "whirl_wep",
		weptype = WPT_SHOES,

		atk = 45,	-- attack power of physical attacks
		acc = 90,	-- accuracy of physical attacks
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
		-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, B, A, B, A, B, A, B, 10, "SPR2_WAIT"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, F, E, D, C, B, A, 1, "SPR2_ROLL"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, E, F, 1, "SPR2_ROLL"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, 1, "SPR2_STND"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- shooting evoker

		anim_special1 = {SPR_PLAY, A, B, C, D, 2, "SPR2_SPIN"}, -- spindash (revving up)
		anim_special2 = {SPR_PLAY, A, B, C, D, 1, "SPR2_SPIN"}, -- spindash (faster, revved up)
		anim_special3 = {SPR_PLAY, A, B, C, D, 2, "SPR2_DASH"}, --ramming

		vfx_summon = {"sfx_wrlsu1", "sfx_wrlsu2"},				-- Summoning Persona to use a Skill
        vfx_skill = {"sfx_wrlsk1", "sfx_wrlsk2", "sfx_wrlsk3", "sfx_wrlsk4"},	-- Used a Skill
        vfx_item = {"sfx_wrlit1", "sfx_wrlit2", "sfx_wrlit3", "sfx_wrlit4"},						-- Used an item
        vfx_hurt = {"sfx_wrlht1", "sfx_wrlht2"},							-- Sustained damage
        vfx_hurtx = {"sfx_wrlhx1", "sfx_wrlhx2"},						-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_wrlde1", "sfx_wrlde2"},		-- Death
        vfx_heal = {"sfx_wrlhe1", "sfx_wrlhe2", "sfx_wrlhe3", "sfx_wrlhe4"},	-- Healed by teammate
        vfx_healself = {"sfx_wrlhsl"},					-- Healed self
        vfx_kill = {"sfx_wrlki1", "sfx_wrlki2"},							-- Killed an enemy
        vfx_1more = {"sfx_wrl1m1", "sfx_wrl1m2"},						-- Performed 1more
        vfx_crit = {"sfx_wrlcr1", "sfx_wrlcr2", "sfx_wrlcr3"},	-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_wrlap1", "sfx_wrlap2"},					-- Ask to All-Out Attack
        vfx_aoado = {"sfx_wrlao1", "sfx_wrlao2"}, -- Performing All-Out Attack
        vfx_aoarelent = {"sfx_wrlad1"},				-- Relenting from All-Out Attack
        vfx_miss = {"sfx_wrlmi1", "sfx_wrlmi2"},						-- Missed attack
        vfx_dodge = {"sfx_wrldo1", "sfx_wrldo2", "sfx_wrldo3"},						-- Dodged enemy attack
        vfx_win = {"sfx_wrlwi1", "sfx_wrlwi2", "sfx_wrlwi3", "sfx_wrlwi4", "sfx_wrlwi5", "sfx_wrlwi6", "sfx_wrlwi7", "sfx_wrlwi8"},	-- Battle won
        vfx_levelup = {"sfx_wrllv1", "sfx_wrllv2", "sfx_wrllv3", "sfx_wrllv4", "sfx_wrllv5"},					-- Level Up!

		icon = "ICO_WHIL",	-- icon for net select and other menus
		hudbust = "WHIRL_H",			-- patch to draw on the stat hud
		hudaoa = "H_WRLAOA",	-- patch for all out attack hud
		hudcutin = "WHIRL_A",	-- cut in
		aoa_quote = "Time to use our\nheads!",

		tip = "A hard-headed lad that wields Strike, Wind, and Buff skills. He's a hard-hitting character for sure, but his SP isn't the highest and he's no tank. Don't be reckless, remember you're part of a team!",
}

personaList["susano-o_whirl"] = {
		name = "Susano-o",
		arcana = ARCANA_FOOL,

		sprite = SPR_SSNO,
		anim_idle = {SPR_SSNO, A, L, B, M, C, N, D, O, 3}, -- Added 4 more standing sprites for it to be smoother
		anim_atk = 	{SPR_SSNO, E, E, E, F, G, H, I, I, I, J, K, K, K, K, K, K, K, K, K, 3},

		strength = 11,
		magic = 6,
		endurance = 7,
		luck = 4,
		agility = 11,
		
		weak = ATK_ELEC,
		block = ATK_WIND,
		
		skills = { 
					{"lunge", 1},
					{"garu", 6},
					
					{"sukukaja", 12},
					{"magaru", 16},
					
					{"dekaja", 20},
					{"sonic punch", 24, "lunge"},
					{"garula", 28, "garu"},
					
					{"wind break", 33},
					{"magarula", 36, "magaru"},
					{"masukukaja", 39, "sukukaja"},
					
					{"wind boost", 42},
					{"gigantic fist", 45, "sonic punch"},
					{"garudyne", 48, "garula"},
					
					{"power charge", 58},
					
					{"god hand", 68, "gigantic fist"},
					
					{"magarudyne", 72, "magarula"},
					{"wind amp", 76, "wind boost"},
				},
}

weaponsList["whirl_wep"] = { --Starting Weapon
	name = "Whirls Shoes",
	type = WPT_SHOES,
	atk = 300,
	rarity = 1,
	slot = "mastery 1",
	desc = "Whirl's Favorite!",
}

VFX_freeslotC("whirl")

attackDefs["whirl_atk1"] = {
		name = "Ram Charge",
		type = ATK_STRIKE,
		power = 60,
		accuracy = 90,
		critical = 2,
		target = TGT_ENEMY,
		cost = CST_HP,
		cost = 0,
		desc = "Ram into an enemy.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
			local target = targets[1]
			local atarget = hittargets[1]
			if timer == 1
				ANIM_set(mo, mo.anim_special3, true)
				mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)
			end

			if not mo.reachedtarget
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo, mo.angle, FRACUNIT*36)
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*36
					damageObject(atarget)
					if target.damagestate ~= DMG_MISS
						localquake(mo.battlen, FRACUNIT*8, 4)
						for i = 1, 2
							createSplat(mo)
						end
						S_StartSound(mobj, sfx_s3k5f)
						S_StartSoundAtVolume(mobj, sfx_s3k59, 128)
						if target.hp > 0
							P_InstaThrust(mo, mo.angle, -FRACUNIT*12)
							mo.momz = 7*FRACUNIT
							ANIM_set(mo, mo.anim_atk, true)
						end
					end
					mo.reachedtarget = timer
				end
			else
				if timer > 20 + mo.reachedtarget
					mo.reachedtarget = nil
					return true
				end
			end
		end,
		critanim = 	function(mo, targets, hittargets, timer)
			local target = targets[1]
			local atarget = hittargets[1]
			if timer == 1
				mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)
			end

			if not mo.reachedtarget
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				P_InstaThrust(mo, mo.angle, FRACUNIT*36)
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*36
					localquake(mo.battlen, FRACUNIT*8, 4)
					for i = 1, 2
						createSplat(mo)
					end
					S_StartSound(mobj, sfx_s3k5f)
					S_StartSoundAtVolume(mobj, sfx_s3k59, 128)
					P_InstaThrust(mo, mo.angle, -FRACUNIT*20)
					mo.momz = 7*FRACUNIT
					ANIM_set(mo, mo.anim_atk, true)
					mo.reachedtarget = timer
				end
			else
				if timer == 1 + mo.reachedtarget
					mo.reachedtarget2 = false
				end
				if timer == 20 + mo.reachedtarget	
					mo.momz = FRACUNIT
					ANIM_set(mo, mo.anim_special1, true)
				end	
				if not mo.reachedtarget2
				and timer > 20 + mo.reachedtarget
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					P_InstaThrust(mo, mo.angle, FRACUNIT*36)
					mo.momz = $+FRACUNIT
					if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*36
						P_SetObjectMomZ(mo, -36*FRACUNIT, false)
						mo.reachedtarget2 = true
					end
				else
					if not mo.reachedtarget3
					and P_IsObjectOnGround(mo)
						damageObject(atarget)
						localquake(mo.battlen, FRACUNIT*8, 4)
						for i = 1, 2
							createSplat(mo)
						end
						S_StartSoundAtVolume(mo, sfx_whrdrl, 128)
						S_StartSound(mo, sfx_whstdr)
						P_InstaThrust(mo, mo.angle, -FRACUNIT*12)
						mo.momz = 7*FRACUNIT
						ANIM_set(mo, mo.anim_atk, true)
						mo.reachedtarget3 = timer
					end
					if mo.reachedtarget3
					and timer >= 20 + mo.reachedtarget3
						mo.reachedtarget = nil
						mo.reachedtarget2 = nil
						mo.reachedtarget3 = nil
						return true
					end
				end
			end
		end,
	}

---------------------------------------

charStats["vesola"] = {

		-- GENERAL

		name = "Vesola",			-- This is only for bots / enemies
		basehp = 43,			-- base HP for level 1
		basesp = 57,
		persona = "metatron_vesola",
		melee_natk = "vesola_atk1",	-- normal melee attack
		
		// Credit to SMS Alfredo for making this stuff work (Along with her wings)
		overlay = MT_VESOLA_STINGER,
		overlaythink = function(mo)
			if not (mo and mo.valid) then return end
		
			local target = mo.target
			local player = target and target.valid and target.control
			
			if player
				P_TeleportMove(target,
					target.x + target.momx,
					target.y + target.momy,
					target.z + target.momz)
				DoVesolaTail(player, mo, target)
				P_TeleportMove(target,
					target.x - target.momx,
					target.y - target.momy,
					target.z - target.momz)
			end
		end,

		wep = "heels_01",
		weptype = WPT_HEELS,

		atk = 35,	-- attack power of physical attacks
		acc = 100,	-- accuracy of physical attacks
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
		-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

		anim_stand = 		{SPR_PLAY, A, 15, "SPR2_STND"},	-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},			-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 30, "SPR2_WAIT"},			-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},			-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},			-- moving
		anim_run =			{SPR_PLAY, A, B, 2, "SPR2_RUN_"},			-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_SHIT"},			-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},			-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 4, "SPR2_ROLL"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},			-- gets revived
		--anim_evoker =		{SPR_WLPS, A, B, 2},	-- holding evoker to head
		--anim_evoker_shoot =	{SPR_WLPS, C, 2},		-- shooting evoker

		anim_special1 = {SPR_PLAY, A, 2, "SPR2_GRND"}, -- sending out the vines

		vfx_summon = {"sfx_vessu1", "sfx_vessu2", "sfx_vessu3", "sfx_vessu4", "sfx_vessu5", "sfx_vessu6", "sfx_vavsla"},				-- Summoning Persona to use a Skill
        vfx_skill = {"sfx_vessk1", "sfx_vessk2", "sfx_vessk3", "sfx_vessk4"},	-- Used a Skill
        vfx_item = {"sfx_vesit1", "sfx_vesit2"},						-- Used an item
        vfx_hurt = {"sfx_vesht1", "sfx_vesht2", "sfx_vesht3", "sfx_vesht4", "sfx_vesht5", "sfx_vesht6", "sfx_vesht7"},							-- Sustained damage
        vfx_hurtx = {"sfx_veshx1", "sfx_veshx2", "sfx_veshx3"},						-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_vesde1", "sfx_vesde2", "sfx_vesde3", "sfx_vesde4"},		-- Death
        vfx_heal = {"sfx_veshe1", "sfx_veshe2", "sfx_veshe3", "sfx_veshe4", "sfx_veshe5"},	-- Healed by teammate
        vfx_healself = {"sfx_veshsl", "sfx_veshs2", "sfx_veshs3", "sfx_veshs4"},					-- Healed self
        vfx_kill = {"sfx_veski1", "sfx_veski2", "sfx_veski3"},							-- Killed an enemy
        vfx_1more = {"sfx_ves1m1", "sfx_ves1m2"},						-- Performed 1more
        vfx_crit = {"sfx_vescr1", "sfx_vescr2", "sfx_vescr3"},	-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {"sfx_vesap1", "sfx_vesap2"},					-- Ask to All-Out Attack
        vfx_aoado = {"sfx_vesao1", "sfx_vesao2"}, -- Performing All-Out Attack
        vfx_aoarelent = {"sfx_vesad1"},				-- Relenting from All-Out Attack
        vfx_miss = {"sfx_vesmi1", "sfx_vesmi2", "sfx_vesmi3", "sfx_vesmi4"},						-- Missed attack
        vfx_dodge = {"sfx_vesdo1", "sfx_vesdo2", "sfx_vesdo3"},						-- Dodged enemy attack
        vfx_win = {"sfx_veswi1", "sfx_veswi2", "sfx_veswi3"},	-- Battle won
        vfx_levelup = {"sfx_veslv1", "sfx_veslv1", "sfx_veslv1"},					-- Level Up!

		icon = "ICO_VESO",	-- icon for net select and other menus
		hudbust = "VESO_H",			-- patch to draw on the stat hud
		hudaoa = "H_VESAOA",	-- patch for all out attack hud
		hudcutin = "VESO_A",	-- cut in
		aoa_quote = "Your corruption ends\nhere.",

		tip = "A headstrong lady bee that uses Bless, Nuke, and Slash skills. While her offensive power may be on par with many she can't support her team very well, so bee mindful of your teammates!",
}

VFX_freeslotC("vesola")

personaList["metatron_vesola"] = {
		-- GENERAL
		name = "Metatron",
		arcana = ARCANA_JUDGEMENT,

		sprite = SPR_MTTR,
		anim_idle = 	{SPR_MTTR, A, B, 10},
		anim_atk = 		{SPR_MTTR, C, C, C, D, D, D, D, D, D, D, D, D, D, D, D, 3},

		strength = 7,
		magic = 11,
		endurance = 8,
		luck = 6,
		agility = 7,

		weak = ATK_CURSE|ATK_ICE,
		resist = ATK_WIND,
		block = ATK_BLESS,
		
		skills = {
					{"kouha", 1}, 
					{"cleave", 9}, 

					{"rakunda", 14}, 
					{"frei", 18},
		  
					{"makouha", 21},
					{"giant slice", 29, "cleave"},
					
					{"swordbreaker", 33},
					{"kouga", 36, "kouha"},
					{"bless boost", 39},
					
					{"freila", 43, "frei"},
					{"makouga", 46, "makouha"},
					{"kougaon", 49, "kouga"},
					
					{"marakunda", 52, "rakunda"},
					{"fatal end", 55, "giant slice"},
					{"freidyne", 58, "freila"},
					
					{"mind charge", 65},
					{"bless amp", 70, "bless boost"},
					
					{"makougaon", 75, "makouga"},
				},
}

freeslot("sfx_lmao")
attackDefs["vesola_atk1"] = {
		name = "Vine Overgrowth",
		type = ATK_PIERCE,
		power = 40,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 0,
		critical = 5,
		norandom = true,
		physical = true,
		desc = "Deals Light Strike damage to\none enemy",
		target = TGT_ENEMY,
		anim_norepel = true,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			mo.vinespacing = $ or 1
			local vinedestx = target.x - 128*cos(target.angle)
			local vinedesty = target.y - 128*sin(target.angle)
			if timer == 1 //This is where we prepare everything :)
				mo.vinespacing = 20
				mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				ANIM_set(mo, mo.anim_special1, true)
				mo.noballs = {}
			end
			
			if timer >= 1 and timer <= 47
				if timer == 1
					mo.noballs = P_SpawnMobj(mo.x, mo.y, mo.z+69*FRACUNIT, MT_DUMMY)
					mo.noballs.state = S_INVISIBLE
					mo.noballs.flags = $|MF_NOGRAVITY
					mo.noballs.fuse = 120
				end
				if timer == 2
				or timer == 11
				or timer == 20
				or timer == 29
				or timer == 38
				or timer == 47
					playSound(mo.battlen, sfx_s3k9b)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					local vineboom = P_SpawnMobj(mo.noballs.x, mo.noballs.y, target.floorz, MT_DUMMY)
					vineboom.state = S_VINESPIKE
					vineboom.frame = A
					vineboom.scale = 0
					vineboom.destscale = FRACUNIT*4/5
					vineboom.scalespeed = FRACUNIT/3
					vineboom.fuse = 20
					local dirt = P_SpawnMobj(vineboom.x+1*FRACUNIT, vineboom.y-1*FRACUNIT, target.floorz, MT_DUMMY)
					dirt.state = S_FLOWERDIRTUPRISE
					dirt.frame = A|FF_ANIMATE
					dirt.scale = FRACUNIT*7/5
					dirt.fuse = 20
					mo.vinespacing = $+65
					P_StartQuake(FRACUNIT*1, 4)
				end
				if mo.noballs and mo.noballs.valid and timer == 1
					mo.noballs.angle = R_PointToAngle2(mo.noballs.x, mo.noballs.y, target.x, target.y)
					P_InstaThrust(mo.noballs, mo.noballs.angle, 7*FRACUNIT)
				end
			end
			
			if timer >= 48 and timer <= 61
				if timer == 56
					playSound(mo.battlen, sfx_s3k9b)
					local vineboom2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					vineboom2.state = S_VINESPIKE
					vineboom2.frame = A
					vineboom2.scale = 0
					vineboom2.destscale = FRACUNIT*4/3
					vineboom2.scalespeed = FRACUNIT/3
					vineboom2.fuse = 20
					local dirt2 = P_SpawnMobj(vineboom2.x+1*FRACUNIT, vineboom2.y-1*FRACUNIT, target.floorz, MT_DUMMY)
					dirt2.state = S_FLOWERDIRTUPRISE
					dirt2.frame = A|FF_ANIMATE
					dirt2.scale = FRACUNIT*5/3
					dirt2.fuse = 20
					P_StartQuake(FRACUNIT*3, 4)
				end
				
				if timer == 61
					damageObject(target)
				end
			end
			
			if timer == 70
				return true
			end
		end,
		critanim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			mo.zzztimer = $ or 1
			mo.vinetimer = $ or 1
			mo.growtimer = $ or 1
			if timer == 1 //This is where we prepare everything :)
				target.flags = $ & ~MF_NOGRAVITY
				target.camtimer = 0
				target.dontpogo = true
				target.flybirdyfly = false
				mo.vinetimer = 1
				mo.zzztimer = 1
				mo.finish = false
				local cam = server.P_BattleStatus[mo.battlen].cam
				mo.prevcamz = cam.z
				target.throwdest = target.z + 300*FRACUNIT
				mo.an = target.angle + 45*ANG1
				mo.cx = target.x + 384*cos(mo.an)
				mo.cy = target.y + 384*sin(mo.an)
				P_TeleportMove(cam, mo.cx, mo.cy, cam.z)
				cam.angle = R_PointToAngle2(mo.cx, mo.cy, target.x, target.y)
				CAM_stop(cam)
				mo.angle = R_PointToAngle(target.x, target.y)
				ANIM_set(mo, mo.anim_special1, true)
				mo.growtimer = 1
			end
			
			if timer >= 1 and timer <= 50
				if leveltime%10 == 0
					for i = 1,3
						local rock = P_SpawnMobj(target.x+5*cos(ANGLE_90*(i-1)), target.y+5*sin(ANGLE_90*(i-1)), target.floorz, MT_FALLINGROCK)
						P_InstaThrust(rock, R_PointToAngle2(rock.x, rock.y, hittargets[1].x, hittargets[1].y), 10*FRACUNIT)
						rock.momz = 13*FRACUNIT
						rock.scale = FRACUNIT/3
						rock.destscale = FRACUNIT/6
						rock.fuse = TICRATE*2
						for j = 1, 3
							local nrock = P_SpawnMobj(rock.x, rock.y, rock.z, MT_FALLINGROCK)
							nrock.momx = P_RandomRange(-6, 6)*FRACUNIT
							nrock.momy = P_RandomRange(-6, 6)*FRACUNIT
							nrock.momz = P_RandomRange(1,3)*FRACUNIT
							nrock.fuse = TICRATE/2
						end
					end
					playSound(mo.battlen, sfx_s3k6f)
				end
			end
			
			if timer >= 25 and timer <= 75
				if timer == 65
					playSound(mo.battlen, sfx_s3k9b)
					local vineboom = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
					vineboom.state = S_VINESPIKE
					vineboom.frame = A
					vineboom.scale = 0
					vineboom.destscale = FRACUNIT*3/2
					vineboom.scalespeed = FRACUNIT/3
					vineboom.fuse = 140
					local dirt = P_SpawnMobj(vineboom.x+2*FRACUNIT, vineboom.y-2*FRACUNIT, target.floorz, MT_DUMMY)
					dirt.state = S_FLOWERDIRTUPRISE
					dirt.frame = A|FF_ANIMATE
					dirt.scale = FRACUNIT*2
					dirt.fuse = 140
					P_StartQuake(FRACUNIT*8, 4)
				elseif timer == 70
					target.flybirdyfly = true
				end
			end

			if target.flybirdyfly
				if target.plyr
					ANIM_set(target, target.anim_death, true)
				else
					ANIM_set(target, target.anim_hurt, true)
				end
				target.rollangle = $+ANG1*60
				target.camtimer = $+1
				mo.vinetimer = $+1
				if mo.vinetimer == 2
					target.momz = (target.throwdest + target.z)/5
					P_InstaThrust(target, mo.angle+P_RandomRange(-180,180)*FRACUNIT, 1*FRACUNIT)
					if target.hp >= 1
						buffStat(target, "def", -25)
						BTL_logMessage(mo.battlen, target.name.."'s Armor was shattered.")
					end
				end
			end

			if target.z == mo.z and mo.vinetimer >= 40 and target.dontpogo and not mo.finish
				target.rollangle = 0
				damageObject(target)
				P_StartQuake(FRACUNIT*12, 1)
				target.dontpogo = false
				mo.finish = true
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i = 1,32
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (11*(i-1))
					dust.destscale = FRACUNIT*10
					dust.state = S_AOADUST1
					dust.frame = A|FF_FULLBRIGHT
					P_InstaThrust(dust, dust.angle, 20*FRACUNIT)
				end
				target.momz = 5*FRACUNIT
				P_InstaThrust(target, mo.angle, 3*FRACUNIT)
				ANIM_set(target, target.anim_hurt, true)
				target.rollangle = $+ANG1*30
				if target.hp <= 0
					local lol = P_RandomRange(1,12)
					local lol2 = P_RandomRange(1,100)
					playSound(mo.battlen, sfx_lmao)
					if lol == 1
						BTL_logMessage(mo.battlen, target.name.." hit the ground too hard.")
					elseif lol == 2
						BTL_logMessage(mo.battlen, target.name.." hit the ground too hard whilst trying to escape "..mo.name..".")
					elseif lol == 3
						BTL_logMessage(mo.battlen, target.name.." fell from a high place.")
					elseif lol == 4
						BTL_logMessage(mo.battlen, target.name.." has died by fall damage.")
					elseif lol == 5
						BTL_logMessage(mo.battlen, target.name.." left a small crater.")
					elseif lol == 6
						BTL_logMessage(mo.battlen, target.name.." discovered gravity.")
					elseif lol == 7
						BTL_logMessage(mo.battlen, target.name.." didn't bounce.")
					elseif lol == 8
						BTL_logMessage(mo.battlen, target.name.." fell victim to gravity.")
					elseif lol == 9
						BTL_logMessage(mo.battlen, target.name.." fell to their death.")
					elseif lol == 10
						BTL_logMessage(mo.battlen, target.name.." hit the ground face first.")
					elseif lol == 11
						BTL_logMessage(mo.battlen, target.name.." faceplanted the ground.")
					elseif lol == 12
						BTL_logMessage(mo.battlen, "death.fell.accident.water")
					end
				elseif target.hp >= 1
					playSound(mo.battlen, sfx_s3k49)
				end
			elseif target.z == mo.z and mo.vinetimer >= 40 and mo.finish
				ANIM_set(target, target.anim_downloop, true)
				mo.zzztimer = $+1
				target.flybirdyfly = false
				if mo.zzztimer == 2
					playSound(mo.battlen, sfx_s3k5d)
				end
				target.rollangle = 0
			end
			
			if mo.zzztimer >= 40
				mo.finish = false
				mo.zzztimer = 1
				mo.vinetimer = 1
				return true
			end
		end,
}

// This is so Dirk and Whirl have their max leveled starting weapons in the shop.
table.insert(shopList["velvet_shop_mp1"].weapons, {makeWeapon("dirk_wep", 10), 800, nil, 4})
table.insert(shopList["velvet_shop_mp1"].weapons, {makeWeapon("whirl_wep", 10), 800, nil, 4})