//Team Kinetic selection mechanic lua by DirkTheHusky
//Heavily inspired by Sonic Classic Heroes
//Potentionally may be a separate addon in the future.
//Man, this is a pain to work with.

rawset(_G, "teamkinetic", false) -- Are we playing as Team Kinetic?
rawset(_G, "loadedbots", false) -- Are the bots added in?
rawset(_G, "leadmember", 0) -- Character that is in control.
rawset(_G, "teamready", false) -- Are we ready to switch between chars

local tkvoices = "client/teamkinetic/voices.dat"
local tkvoice_enabled = true

local file = io.openlocal(tkvoices, "r")
if file then
    if file:read("*n") == 0
		tkvoice_enabled = false
	end
end

freeslot(
	"sfx_vadirk",
	"sfx_vawhrl",
	"sfx_vavsla"
)

-- I/O and command for voices

COM_AddCommand("tkvoices", function(player, arg)
	local activated = false
	if tkvoice_enabled == true
		activated = "on."
	else
		activated = "off."
	end
	
	if arg == "1" or arg == "yes" or arg == "on"
		local va = io.openlocal(tkvoices, "w+")
		va:write(1)
		va:close()
		tkvoice_enabled = true
		CONS_Printf(player, "Custom voices are on.")
	elseif arg == "0" or arg == "no" or arg == "off"
		local va = io.openlocal(tkvoices, "w+")
		va:write(0)
		va:close()
		tkvoice_enabled = false
		CONS_Printf(player, "Custom voices are off.")
	else
		CONS_Printf(player, "Toggles voice acting. Voice acting is " +activated)
	end
end)

-- Player to spawn point provided by Lach

local function PlayerToSpawnPoint(player)
	local mo = player.mo

	-- can't teleport if there's no mobj
	if not player.mo
		return
	end

	local id = #player + 1 -- get the spawn point number for this player
	local spawnPoint

	-- look for a spawn point for this player
	for mt in mapthings.iterate
		if mt.type == id
			spawnPoint = mt
		end
	end

	-- can't teleport if there's no spawn point
	if spawnPoint == nil
		return
	end

	-- find the coordinates for this spawn point
	local x, y, z = spawnPoint.x * FRACUNIT, spawnPoint.y * FRACUNIT, spawnPoint.z * FRACUNIT
	local sector = R_PointInSubsector(x, y).sector

	if spawnPoint.options & MTF_OBJECTFLIP
		z = sector.ceilingheight - $ - mo.height
		mo.flags2 = $ | MF2_OBJECTFLIP
		mo.eflags = $ | MFE_VERTICALFLIP
	else
		z = sector.floorheight + $
		mo.flags2 = $ & ~MF2_OBJECTFLIP
		mo.eflags = $ & ~MFE_VERTICALFLIP
	end

	-- teleport the player to the spawn point
	(P_SetOrigin or P_TeleportMove)(mo, x, y, z)
end

 
addHook("BotTiccmd", function(bot,cmd)
	local player = players[0]
	local mo = players[0].mo
	
	if not multiplayer and not netgame and mo and mo.valid and bot and bot.valid
		if mo.skin == "dirk" and bot.mo.skin == "sonic"
		and player.realtime == 1
		and not loadedbots == true
		and teamkinetic == false
			local leadmember
		
			leadmember = 0
			player.secondmember = bot
			player.thirdmember = G_AddPlayer("vesola", SKINCOLOR_HONEY, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
			loadedbots = true -- We're all set. Set this to true
			teamkinetic = true
			if leadmember == 0
				R_SetPlayerSkin(player.secondmember, "whirl")
				R_SetPlayerSkin(player.thirdmember, "vesola")
				PlayerToSpawnPoint(player.thirdmember)
			elseif leadmember == 1
				R_SetPlayerSkin(player.secondmember, "vesola")
				R_SetPlayerSkin(player.thirdmember, "dirk")
				PlayerToSpawnPoint(player.thirdmember)
			elseif leadmember == 2
				R_SetPlayerSkin(player.secondmember, "dirk")
				R_SetPlayerSkin(player.thirdmember, "whirl")
				PlayerToSpawnPoint(player.thirdmember)
			end
		end
		if teamkinetic == true
			if mo.teamtime == 1
				PlayerToSpawnPoint(player.thirdmember)
			end
			--if player.thirdmember == nil
			if loadedbots == false
				if leadmember == 0
					R_SetPlayerSkin(player.secondmember, "whirl")
					player.thirdmember = G_AddPlayer("vesola", SKINCOLOR_HONEY, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
					PlayerToSpawnPoint(player.thirdmember)
				elseif leadmember == 1
					R_SetPlayerSkin(player.secondmember, "vesola")
					player.thirdmember = G_AddPlayer("dirk", SKINCOLOR_DUSK, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
					PlayerToSpawnPoint(player.thirdmember)
				elseif leadmember == 2
					R_SetPlayerSkin(player.secondmember, "dirk")
					player.thirdmember = G_AddPlayer("whirl", SKINCOLOR_SKY, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
					PlayerToSpawnPoint(player.thirdmember)
				end
				loadedbots = true
			end
		end
		//Save data attempt
		if ((mo.skin == "dirk" or mo.skin == "whirl" or mo.skin == "vesola") and (bot.mo.skin == "dirk" or bot.mo.skin == "whirl" or bot.mo.skin == "vesola"))
		and player.realtime <= 1
		and not loadedbots == true
		and teamkinetic == false
		and not (mo.skin == "dirk" and bot.mo.skin == "whirl")
			player.secondmember = bot
			if (mo.skin == "dirk" and bot.mo.skin == "vesola")
				leadmember = 0
			elseif (mo.skin == "whirl" and bot.mo.skin == "dirk")
				leadmember = 1
			elseif (mo.skin == "vesola" and bot.mo.skin == "whirl")
				leadmember = 2
			end
			if leadmember == 0
				R_SetPlayerSkin(player.secondmember, "whirl")
				player.thirdmember = G_AddPlayer("vesola", SKINCOLOR_HONEY, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
				PlayerToSpawnPoint(player.thirdmember)
			elseif leadmember == 1
				R_SetPlayerSkin(player.secondmember, "vesola")
				player.thirdmember = G_AddPlayer("dirk", SKINCOLOR_DUSK, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
				PlayerToSpawnPoint(player.thirdmember)
			elseif leadmember == 2
				R_SetPlayerSkin(player.secondmember, "dirk")
				player.thirdmember = G_AddPlayer("whirl", SKINCOLOR_SKY, "3rd_member", BOT_2PAI) --Trying out this on a third bot on the party.
				PlayerToSpawnPoint(player.thirdmember)
			end
			teamkinetic = true
			loadedbots = true
		end
	end
end)

addHook("PlayerThink", function(player)
	if loadedbots == true --Did we add all the bots needed?		
		if player.mo and player.mo.valid --Is the leader player exist?
			if (player.mo.skin == "dirk" or player.mo.skin == "whirl" or player.mo.skin == "vesola") --Is the leader using those skins?
				
				local second = player.secondmember
				local third = player.thirdmember
				
				if player.mo.teamtime == nil
					player.mo.teamtime = 0
				end
				
				player.mo.teamtime = $+1
				
				//Don't do the team switch unless we're actually ready.
				
				if P_PlayerInPain(player)
				or player.playerstate
				or not player.mo.health
				or (player.pflags & PF_FULLSTASIS)
				or (player.pflags & PF_SPINNING) -- Dirk check
				or (player.pflags & PF_STARTDASH) -- Dirk check
				or (player.pflags & PF_THOKKED)
				or (player.pflags & PF_SHIELDABILITY)
				or (player.pflags & PF_SLIDING)
				or (player.pflags & PF_FINISHED)
				or (player.panim == PA_PAIN and not (player.pflags&PF_JUMPED))
				or (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6) -- Super check
				or player.powers[pw_carry]
				or player.mo.eflags&MFE_SPRUNG -- Whirl/Vesola check
				or player.whirltornadojump -- Whirl check
				or player.mo.state == S_PLAY_DRILL_LAND -- Whirl check
				or player.whirlram == true -- Whirl check
				or player.mo.beeflying == true -- Vesola check
				or player.mo.charging == true -- Vesola check
				or player.powers[pw_nocontrol] > 0
				or player.mo.teamtime < TICRATE
				or (player.isxmomentum and player.mo.state == S_PLAY_FACEPLANT) -- Xmomentum check
				or (player.isxmomentum and (player.mo.state >= S_PLAY_HYPERTRNS_1 and player.mo.state <= S_PLAY_HYPERTRNS_6)) -- Xmomentum check
					teamready = false
				else
					teamready = true
				end
				
				if not player.mo.buttondown
					player.mo.buttondown = false
				end
				if not (player.cmd.buttons & BT_WEAPONNEXT or player.cmd.buttons & BT_WEAPONPREV)
					player.mo.buttondown = false
				end
				
				if player.cmd.buttons & BT_WEAPONNEXT
				and player.mo.buttondown == false
					if teamready == true
						if leadmember == 0
							leadmember = 1
							R_SetPlayerSkin(player, "whirl")
							R_SetPlayerSkin(second, "vesola")
							R_SetPlayerSkin(third, "dirk")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vawhrl)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						elseif leadmember == 1
							leadmember = 2
							R_SetPlayerSkin(player, "vesola")
							R_SetPlayerSkin(second, "dirk")
							R_SetPlayerSkin(third, "whirl")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vavsla)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						elseif leadmember == 2
							leadmember = 0
							R_SetPlayerSkin(player, "dirk")
							R_SetPlayerSkin(second, "whirl")
							R_SetPlayerSkin(third, "vesola")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vadirk)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						end
					else
						S_StartSound(player.mo, sfx_adderr)
						player.mo.buttondown = true
					end
				elseif player.cmd.buttons & BT_WEAPONPREV
				and player.mo.buttondown == false
					if teamready == true
						if leadmember == 0
							leadmember = 2
							R_SetPlayerSkin(player, "vesola")
							R_SetPlayerSkin(second, "dirk")
							R_SetPlayerSkin(third, "whirl")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vavsla)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						elseif leadmember == 1
							leadmember = 0
							R_SetPlayerSkin(player, "dirk")
							R_SetPlayerSkin(second, "whirl")
							R_SetPlayerSkin(third, "vesola")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vadirk)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						elseif leadmember == 2
							leadmember = 1
							R_SetPlayerSkin(player, "whirl")
							R_SetPlayerSkin(second, "vesola")
							R_SetPlayerSkin(third, "dirk")
							if tkvoice_enabled == true
								S_StartSound(player.mo, sfx_vawhrl)
							else
								S_StartSound(player.mo, sfx_s3kc3s)
							end
							player.mo.buttondown = true
						end
					else
						S_StartSound(player.mo, sfx_adderr)
						player.mo.buttondown = true
					end
				end	
			
				player.charflags = $|SF_SUPER -- Everyone can go super
			end
			-- Replicating some Xmom code because its the only code I know that makes the bots go super. Xmom belongs to Frostiikin.
			if player.bot and players[0] and players[0].valid and players[0].powers[pw_super]
				player.rings = players[0].rings
				if players[0].mo.state == S_PLAY_SUPER_TRANS1
				or players[0].mo.state == S_PLAY_SUPER_TRANS2
				or players[0].mo.state == S_PLAY_SUPER_TRANS3
				or players[0].mo.state == S_PLAY_SUPER_TRANS4
				or players[0].mo.state == S_PLAY_SUPER_TRANS5
				or players[0].mo.state == S_PLAY_SUPER_TRANS6
					if not player.powers[pw_super]
						P_DoSuperTransformation(player, false)
						--player.mo.state = S_PLAY_SUPER_TRANS1
					end
				end
				if not player.powers[pw_super]
					player.powers[pw_super] = 1
				end
			end
			if player.powers[pw_carry] == CR_NIGHTSMODE
				G_RemovePlayer(2)
				loadedbots = false
				--teamkinetic = false
			end
			
			if not (player.mo.skin == "dirk" or player.mo.skin == "whirl" or player.mo.skin == "vesola") --Is the leader using those skins?
			and teamkinetic == true
				G_RemovePlayer(1)
				G_RemovePlayer(2)
				loadedbots = false
				teamkinetic = false
				leadmember = nil
				player.mo.teamtime = -1 -- We stay at negative value instead of returning to nil
			end
		end
	end
end)

hud.add(function(v,p)
	if srb2p
		return
	end

	if loadedbots == true
	and teamkinetic == true
	and p.secondmember.mo and p.secondmember.mo.valid
	and p.thirdmember.mo and p.thirdmember.mo.valid
	or not p.powers[pw_carry] == CR_NIGHTSMODE --We aren't showing this HUD in NiGHTS mode
		hud.disable("lives")
		if v.overlaytime == nil
			v.overlaytime = 0
		end
		
		local video = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS
		local videotext = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_ALLOWLOWERCASE
		
		local playericon = v.getSprite2Patch(p.mo.skin, SPR2_XTRA, A)
		local secondicon = v.getSprite2Patch(p.secondmember.mo.skin, SPR2_XTRA, A)
		local thirdicon = v.getSprite2Patch(p.thirdmember.mo.skin, SPR2_XTRA, A)
		
		local superplayericon = v.getSprite2Patch(p.mo.skin, SPR2_XTRA, true)
		local supersecondicon = v.getSprite2Patch(p.secondmember.mo.skin, SPR2_XTRA, true)
		local superthirdicon = v.getSprite2Patch(p.thirdmember.mo.skin, SPR2_XTRA, true)
		
		local livex = v.cachePatch("STLIVEX")
		local infinity = v.cachePatch("STCFN022")
		
		local primarycolor = v.getColormap(p.mo.skin, p.mo.color)
		local secondarycolor = v.getColormap(p.secondmember.mo.skin, p.secondmember.mo.color)
		local thirdcolor = v.getColormap(p.thirdmember.mo.skin, p.thirdmember.mo.color)
		
		local overlayflag
		
		if v.overlaytime == 0
			overlayflag = V_10TRANS
		end
		
		if p.mo.state == S_PLAY_SUPER_TRANS1
		or p.mo.state == S_PLAY_SUPER_TRANS2
		or p.mo.state == S_PLAY_SUPER_TRANS3
		or p.mo.state == S_PLAY_SUPER_TRANS4
		or p.mo.state == S_PLAY_SUPER_TRANS5
			v.overlaytime = 0
			overlayflag = V_90TRANS
		elseif p.mo.state == S_PLAY_SUPER_TRANS6
			v.overlaytime = $+1
			if v.overlaytime >= 20
				overlayflag = V_90TRANS
			end
		end
		if v.overlaytime > 0
			overlayflag = (v.overlaytime/2)<<V_ALPHASHIFT
		end
		if v.overlaytime >= 20
			overlayflag = V_90TRANS
		end
		
		--v.drawString(160, 32, v.overlaytime, V_ALLOWLOWERCASE)
		--v.drawString(160, 64, v.overlaytime/2, V_ALLOWLOWERCASE)
		
		local overlay = V_SNAPTOLEFT|V_SNAPTOBOTTOM|overlayflag
		
		/*if v.overlaytime >= 2 and v.overlaytime < 4
			overlayflag = V_10TRANS
		elseif v.overlaytime >= 4 and v.overlaytime < 6
			overlayflag = V_20TRANS
		elseif v.overlaytime >= 6 and v.overlaytime < 8
			overlayflag = V_30TRANS
		elseif v.overlaytime >= 8 and v.overlaytime < 10
			overlayflag = V_40TRANS
		elseif v.overlaytime >= 10 and v.overlaytime < 12
			overlayflag = V_50TRANS
		elseif v.overlaytime >= 12 and v.overlaytime < 14
			overlayflag = V_60TRANS
		elseif v.overlaytime >= 14 and v.overlaytime < 16
			overlayflag = V_70TRANS
		elseif v.overlaytime >= 16 and v.overlaytime < 18
			overlayflag = V_80TRANS
		elseif v.overlaytime >= 18 and v.overlaytime < 20
			overlayflag = V_90TRANS
		end*/	
		
		local overlay1color = v.getColormap(p.mo.skin, p.skincolor)
		local overlay2color = v.getColormap(p.secondmember.mo.skin, p.secondmember.skincolor)
		local overlay3color = v.getColormap(p.thirdmember.mo.skin, p.thirdmember.skincolor)
		
		v.drawScaled(16*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/13, playericon, video, primarycolor)
		v.drawScaled(45*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, secondicon, video, secondarycolor)
		v.drawScaled(62*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, thirdicon, video, thirdcolor)
		
		if p.powers[pw_super]
			v.drawScaled(16*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/13, superplayericon, video, primarycolor)
			v.drawScaled(45*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, supersecondicon, video, secondarycolor)
			v.drawScaled(62*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, superthirdicon, video, thirdcolor)
			
			if v.overlaytime > 0 and v.overlaytime < 20
				v.drawScaled(16*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/13, superplayericon, overlay, overlay1color)
				v.drawScaled(45*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, supersecondicon, overlay, overlay2color)
				v.drawScaled(62*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, superthirdicon, overlay, overlay3color)
			end
		else
			v.drawScaled(16*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/13, playericon, video, primarycolor)
			v.drawScaled(45*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, secondicon, video, secondarycolor)
			v.drawScaled(62*FRACUNIT, 164*FRACUNIT, 10*FRACUNIT/24, thirdicon, video, thirdcolor)
		end
		
		v.drawScaled(44*FRACUNIT, 182*FRACUNIT, FRACUNIT, livex, video)
		
		if p.lives == 127
			v.drawScaled(62*FRACUNIT, 180*FRACUNIT, FRACUNIT, infinity, video)
		else
			v.drawString(62, 180, p.lives, videotext)
		end
	else
		hud.enable("lives")
	end
end, "game")

/*addHook("IntermissionThinker", function()
	local player = consoleplayer
	if not (multiplayer or splitscreen)
		if loadedbots == true
			skins[player.skin].realname = "Team_Kinetic"
		end
	end
end)*/

// Turn out the loadbots value when we exit the main game

addHook("GameQuit", function()
	teamkinetic = false
	loadedbots = false
end)

addHook("ThinkFrame", function()
	if gamestate == GS_TITLESCREEN
		teamkinetic = false
		loadedbots = false
	end
end)