//Vesola's SRB2 Battle abilities by DirkTheHusky
//Fixes from Lactozilla

/*Man, figuring out the petal bullets despawning was a pain in the butt for me.
Why didn't I think about using MobjThinker in the first place for that.
*/

local vesola_cooldown = TICRATE*2
local vesola_shoottime = TICRATE

local VesolaBattle = false
--local B = CBW_Battle

//Functions for the bullets
//-------------------------------

local function movebullet(bullet, fire, xpos, ypos, zpos)
	if bullet and bullet.valid then
		local px = FixedMul(xpos, sin(fire.angle))
		local py = FixedMul(ypos, cos(fire.angle))
	
		--P_InstaThrust(bullet, fire.angle+dir, xydir)
		P_SetScale(bullet, bullet.destscale)
		P_TeleportMove(bullet, fire.x+px, fire.y-py, fire.z+zpos)
	end
end

local function stopandaim(bullet, fire, xpos, ypos, zpos)
	if bullet and bullet.valid then
		P_SetObjectMomZ(bullet, 0, false)
		P_InstaThrust(bullet, fire.angle, 0)
		bullet.angle = fire.angle
		local px = FixedMul(xpos, sin(fire.angle))
		local py = FixedMul(ypos, cos(fire.angle))

		P_TeleportMove(bullet, fire.x+px, fire.y-py, fire.z+zpos)
	end
end

local function firebullet(bullet, sender, speed)
	if bullet and bullet.valid then
		S_StartSound(bullet, sfx_cdfm62)
		P_InstaThrust(bullet, sender.angle, speed*FRACUNIT)
	end
end

local function bullettrail(bullet)
	if bullet and bullet.valid then
		local trail = P_SpawnGhostMobj(bullet)
		trail.fuse = 7
		trail.colorized = true
	end
end

addHook("MobjThinker", function(mobj)
	if mobj.fired then
        mobj.flags = $ &~ (MF_BOUNCE|MF_GRENADEBOUNCE)
        mobj.blockable = 1
        mobj.block_stun = 3
        //mobj.block_sound = sfx_s3kb5
        mobj.block_hthrust = 9
        mobj.block_vthrust = 2
        mobj.spawnfire = true
        return
    else
        mobj.flags = $|MF_BOUNCE|MF_GRENADEBOUNCE
        mobj.hit_sound = sfx_hit03
        mobj.blockable = 1
        mobj.block_stun = 3
        //mobj.block_sound = sfx_s3kb5
        mobj.block_hthrust = 6
        mobj.block_vthrust = 4
    end

	local target = mobj.target
	if (not target)
	or (target and not target.valid) then
		P_RemoveMobj(mobj)
		return
	end

	local player = target.player
	if (not player)
	or (player and (
		P_PlayerInPain(player)
		or player.playerstate == PST_DEAD
		or player.spectator
		or player.actionstate == 0
	)) then
		P_RemoveMobj(mobj)
	end
end, MT_PETALATTACK)

addHook("MobjSpawn",function(mo)
	mo.hit_sound = sfx_hit03
	mo.blockable = 1
	mo.block_stun = 8
	//mo.block_sound = sfx_s3kb5
	mo.block_hthrust = 7
	mo.block_vthrust = 6
	mo.spawnfire = true
end,MT_PETALTWIRLPIECE)

addHook("MobjSpawn",function(mo)
	mo.hit_sound = sfx_hit03
end,MT_PETALATTACK)

/*local function DoPlayerKnockback(player, inflictor, source)
	if player.powers[pw_invulnerability]
	or player.powers[pw_flashing]
	or player.powers[pw_super] then
		return
	end

	player.pflags = $ & ~PF_APPLYAUTOBRAKE
	P_ResetPlayer(player)

	player.mo.z = $ + P_MobjFlip(player.mo)

	if (player.mo.eflags & MFE_UNDERWATER) then
		P_SetObjectMomZ(player.mo, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
	else
		P_SetObjectMomZ(player.mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
	end

	local ang = R_PointToAngle2(source.x - source.momx, source.y - source.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
	local fallbackspeed = max(abs(source.player.speed), FixedMul(4*FRACUNIT, inflictor.scale))

	player.drawangle = ang + ANGLE_180
	P_InstaThrust(player.mo, ang, fallbackspeed)
end*/

addHook("ShouldDamage", function(target, inflictor, source)
	if not (CBW_Battle and CBW_Battle.BattleGametype())
		return
	end

	if (target.player and target.health)
	and (source and source.valid and source.player and (source ~= target))
	and (inflictor and inflictor.valid and (inflictor.type == MT_PETALTWIRLPIECE)) then
		--DoPlayerKnockback(target.player, inflictor, source)
		return false
	end
end, MT_PLAYER)

//-------------------------------

//Base attack

local function VesolaSpecial(mo,doaction,pressedaction)
	local player = mo.player
	
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD then
		player.bullettime = 0
		player.bulletfiretime = 0
		player.actionstate = 0
	end
	
	if not(CBW_Battle.CanDoAction(player)) 
		player.actionstate = 0
	return end
	
	//Action Info
	player.actiontext = "Petal Bullets"
	player.actionrings = 10

	if player.actionstate != 0 then 
		player.canguard = false
	end
	
	if player.bullettime == nil then
		player.bullettime = 0
	end
	
	if player.bulletfiretime == nil then
		player.bulletfiretime = 0
	end
	
	if player.actionstate == 0
		player.bullettime = 0
		player.bulletfiretime = 0
		if doaction == 1
			CBW_Battle.PayRings(player)
			player.actionstate = 1
			CBW_Battle.ApplyCooldown(player,vesola_cooldown)
			player.normalspeed = skins["vesola"].normalspeed
			player.thrustfactor = skins["vesola"].thrustfactor
		end
	end
	if player.actionstate
		if player.actionstate == 1
		and not P_PlayerInPain(player)
			player.bullettime = $+1
			player.pflags = $ | PF_THOKKED
			player.drawangle = mo.angle
			
			local firedir = mo.angle // Set up the fire direction
			local playerang = FixedMul(cos(mo.angle), sin(mo.angle))
			
			if player.bullettime == 1
				player.bullet1 = P_SpawnMobj(mo.x, mo.y, mo.z+16*mo.scale, MT_PETALATTACK)
				player.bullet1.scale = 0
				player.bullet1.destscale = 2*FRACUNIT
				player.bullet1.color = mo.color
				player.bullet1.target = mo
				player.bullet1.angle = mo.angle + ANGLE_90
				player.bullet1.scale = mo.scale*2
				player.bullet1.skin = mo.skin
				player.bullet1.flags2 = mo.flags2
				player.bullet1.eflags = mo.eflags
				player.bullet1.fired = false
				
				S_StartSound(mo, sfx_s3k8e)
				
				player.bullet2 = P_SpawnMobj(mo.x, mo.y, mo.z+16*mo.scale, MT_PETALATTACK)
				player.bullet2.scale = 0
				player.bullet2.destscale = 2*FRACUNIT
				player.bullet2.color = mo.color
				player.bullet2.target = mo
				player.bullet2.angle = mo.angle + ANGLE_270
				player.bullet2.scale = mo.scale*2
				player.bullet2.skin = mo.skin
				player.bullet2.flags2 = mo.flags2
				player.bullet2.eflags = mo.eflags
				player.bullet2.angle = firedir
				player.bullet2.fired = false
				
				player.bullet3 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PETALATTACK)
				player.bullet3.scale = 0
				player.bullet3.destscale = 2*FRACUNIT
				player.bullet3.color = mo.color
				player.bullet3.target = mo
				player.bullet3.angle = mo.angle + ANGLE_90
				player.bullet3.scale = mo.scale*2
				player.bullet3.skin = mo.skin
				player.bullet3.flags2 = mo.flags2
				player.bullet3.eflags = mo.eflags
				player.bullet3.angle = firedir
				player.bullet3.fired = false

				player.bullet4 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PETALATTACK)
				player.bullet4.scale = 0
				player.bullet4.destscale = 2*FRACUNIT
				player.bullet4.color = mo.color
				player.bullet4.target = mo
				player.bullet4.angle = mo.angle + ANGLE_270
				player.bullet4.scale = mo.scale*2
				player.bullet4.skin = mo.skin
				player.bullet4.flags2 = mo.flags2
				player.bullet4.eflags = mo.eflags
				player.bullet4.angle = firedir
				player.bullet4.fired = false
				
			end
			
			--print((60*player.bullettime/17)*FRACUNIT)
			
			if player.bullettime < TICRATE/2
				player.powers[pw_nocontrol] = 1
				player.drawangle = mo.angle
				movebullet(player.bullet1, mo, (-60*player.bullettime/17)*mo.scale, (-60*player.bullettime/17)*mo.scale, (48*player.bullettime/17)*mo.scale)
				movebullet(player.bullet2, mo, (60*player.bullettime/17)*mo.scale, (60*player.bullettime/17)*mo.scale, (48*player.bullettime/17)*mo.scale)
				movebullet(player.bullet3, mo, (-60*player.bullettime/17)*mo.scale, (-60*player.bullettime/17)*mo.scale, 0)
				movebullet(player.bullet4, mo, (60*player.bullettime/17)*mo.scale, (60*player.bullettime/17)*mo.scale, 0)
				/*movebullet(player.bullet1, mo, ANGLE_90, 3*mo.scale)
				movebullet(player.bullet2, mo, ANGLE_270, 3*mo.scale)
				movebullet(player.bullet3, mo, ANGLE_90, 3*mo.scale)
				movebullet(player.bullet4, mo, ANGLE_270, 3*mo.scale)*/
				if player.bullet1 and player.bullet1.valid then
					--P_SetObjectMomZ(player.bullet1, FRACUNIT, false)
					player.bullet1.scale = mo.scale*2
				end
				if player.bullet2 and player.bullet2.valid then
					--P_SetObjectMomZ(player.bullet2, FRACUNIT, false)
					player.bullet2.scale = mo.scale*2
				end
				if player.bullet3 and player.bullet3.valid then
					player.bullet3.scale = mo.scale*2
				end
				if player.bullet4 and player.bullet4.valid then
					player.bullet4.scale = mo.scale*2
				end
			elseif player.bullettime >= TICRATE/2 and player.bullettime < 57
				player.drawangle = mo.angle
				stopandaim(player.bullet1, mo, -60*mo.scale, -60*mo.scale, 48*mo.scale)
				stopandaim(player.bullet2, mo, 60*mo.scale, 60*mo.scale, 48*mo.scale)
				stopandaim(player.bullet3, mo, -60*mo.scale, -60*mo.scale, 0)
				stopandaim(player.bullet4, mo, 60*mo.scale, 60*mo.scale, 0)
				if player.bullet1 and player.bullet1.valid then
					player.bullet1.flags = $|MF_MISSILE
					player.bullet1.scale = mo.scale*2
				end
				if player.bullet2 and player.bullet2.valid then
					player.bullet2.flags = $|MF_MISSILE
					player.bullet2.scale = mo.scale*2
				end
				if player.bullet3 and player.bullet3.valid then
					player.bullet3.flags = $|MF_MISSILE
					player.bullet3.scale = mo.scale*2
				end
				if player.bullet4 and player.bullet4.valid then
					player.bullet4.flags = $|MF_MISSILE
					player.bullet4.scale = mo.scale*2
				end
			end
			if player.bullettime == 40
				if player.bullet1 and player.bullet1.valid then
					player.bullet1.angle = firedir
				end
				if player.bullet2 and player.bullet2.valid then
					player.bullet2.angle = firedir
				end
				if player.bullet3 and player.bullet3.valid then
					player.bullet3.angle = firedir
				end
				if player.bullet4 and player.bullet4.valid then
					player.bullet4.angle = firedir
				end
			
				player.actionstate = 2
			end
		end
		
		/*if player.bullet1 and player.bullet1.valid then
			P_TeleportMove(player.bullet1, FixedMul(player.bullet1.x, cos(mo.angle)),0,player.bullet1.z)
		end
		if player.bullet2 and player.bullet2.valid then
			P_TeleportMove(player.bullet2, FixedMul(player.bullet2.x, cos(mo.angle)),0,player.bullet2.z)
		end
		if player.bullet3 and player.bullet3.valid then
			P_TeleportMove(player.bullet3, FixedMul(player.bullet3.x, cos(mo.angle)),0,player.bullet3.z)
		end
		if player.bullet4 and player.bullet4.valid then
			P_TeleportMove(player.bullet4, FixedMul(player.bullet4.x, cos(mo.angle)),0,player.bullet4.z)
		end*/
		
		
		if player.actionstate == 2
			player.bulletfiretime = $+1
			if player.bulletfiretime == 1
			and player.bullet1 and player.bullet1.valid
				firebullet(player.bullet1, player.bullet1, 72)
				player.bullet1.fired = true
				player.pflags = $ & ~PF_THOKKED
			elseif player.bulletfiretime == 7
			and player.bullet2 and player.bullet2.valid
				firebullet(player.bullet2, player.bullet2, 72)
				player.bullet2.fired = true
			elseif player.bulletfiretime == 13
			and player.bullet3 and player.bullet3.valid
				firebullet(player.bullet3, player.bullet3, 72)
				player.bullet3.fired = true
			elseif player.bulletfiretime == 19
				if player.bullet4 and player.bullet4.valid
					firebullet(player.bullet4, player.bullet4, 72)
					player.bullet4.fired = true
				end
				player.actionstate = 0
				player.bullettime = 0
				player.bulletfiretime = 0
			end
		end
		bullettrail(player.bullet1)
		bullettrail(player.bullet2)
		bullettrail(player.bullet3)
		bullettrail(player.bullet4)
	end
end

local KineticExhaustV = function(player)
	if player.mo.hornetsting == 1
	and player.gotflagdebuff
		player.mo.hornettime = 2*TICRATE
	end
	return false
end

//Base Setup!
			
addHook("ThinkFrame",function()
	if (CBW_Battle and not VesolaBattle)
		local function KineticPriorityV(player)
			if player.mo.hornetsting == 2
				CBW_Battle.SetPriority(player,1,1,"fang_tailbounce",2,1,"Sting Strike")
			end
		end
			
	
		CBW_Battle.SkinVars["vesola"] = {
			weight = 95,
			shields = 1,
			special = VesolaSpecial,
			guard_enabled = true,
			guard_frame = 2,
			func_priority_ext = KineticPriorityV,
			func_exhaust = KineticExhaustV
		}
	
		VesolaBattle = true
		print("Vesola BattleMod functions have been loaded.")
	end
end)

